Subject: Re: bug#61161: package-input-rewriting causes different ordering of grafts

From: Josselin Poiret <[email-masked]>
Date: Wed, 01 Feb 2023 18:23:21 +0100

Hi Akira,

Akira Kyle <[email-masked]> writes:

> Inspecting these derivations, the difference between them seems to 
> be that in the former has zlib first in the `mapping` field of the 
> graft while in the latter zlib is last. My guess is this is due to 
> the fact that the emacs-compat override adds lzip to its 
> native-inputs and causes a different traversal order for grafting 
> zlib. But this is my first time attempting to look at the grafting 
> machinery in detail, so hopefully the experts can figure out if 
> this really is a bug and how to fix it!
>
> I don't have a concrete example where this causes issues in 
> practice, since here the two packages would conflict anyways due 
> to different compat versions, but it seems like that's mostly a 
> consequence of emacs-packages having propagated dependencies. At 
> the very least it would seem to cause unnecessary duplication in 
> the store.

This makes me think of [1], which was supposedly fixed, although from
what I remember we didn't actually find out what was causing this.

[1] https://issues.guix.gnu.org/58419

Best,
-- 
Josselin Poiret